---
title: Locating DOM elements using selectors
slug: Web/API/Document_object_model/Locating_DOM_elements_using_selectors
tags:
  - Beginner
  - DOM
  - NeedsBeginnerUpdate
---
<p>The Selectors API provides methods that make it quick and easy to retrieve {{domxref("Element")}} nodes from the DOM by matching against a set of selectors. This is much faster than past techniques, wherein it was necessary to, for example, use a loop in JavaScript code to locate the specific items you needed to find.</p>

<h2 id="The_NodeSelector_interface">The NodeSelector interface</h2>

<p>This specification adds two new methods to any objects implementing the {{domxref("Document")}}, {{domxref("DocumentFragment")}}, or {{domxref("Element")}} interfaces:</p>

<dl>
 <dt>{{domxref("Element.querySelector", "querySelector()")}}</dt>
 <dd>Returns the first matching {{domxref("Element")}} node within the node's subtree. If no matching node is found, <code>null</code> is returned.</dd>
 <dt>{{domxref("Element.querySelectorAll", "querySelectorAll()")}}</dt>
 <dd>Returns a {{domxref("NodeList")}} containing all matching <code>Element</code> nodes within the node's subtree, or an empty <code>NodeList</code> if no matches are found.</dd>
</dl>

<div class="note"><strong>Note:</strong> The {{domxref("NodeList")}} returned by {{domxref("Element.querySelectorAll()", "querySelectorAll()")}} is not live, which means that changes in the DOM are not reflected in the collection. This is different from other DOM querying methods that return live node lists.</div>

<p>You may find examples and details by reading the documentation for the {{domxref("Element.querySelector()")}} and {{domxref("Element.querySelectorAll()")}} methods, as well as in the article <a class="internal" href="/en-US/docs/Code_snippets/QuerySelector" title="en-US/docs/Code snippets/QuerySelector">Code snippets for querySelector</a>.</p>

<h2 id="Selectors">Selectors</h2>

<p>The selector methods accept one or more comma-separated selectors to determine what element or elements should be returned. For example, to select all paragraph (<code>p</code>) elements in a document whose CSS class is either <code>warning</code> or <code>note</code>, you can do the following:</p>

<pre class="notranslate"><code>var special = document.querySelectorAll("p.warning, p.note");</code></pre>

<p>You can also query by ID. For example:</p>

<pre class="notranslate"><code>var el = document.querySelector("#main, #basic, #exclamation");</code></pre>

<p>After executing the above code, <code>el</code> contains the first element in the document whose ID is one of <code>main</code>, <code>basic</code>, or <code>exclamation</code>.</p>

<p>You may use any CSS selectors with the <code>querySelector()</code> and <code>querySelectorAll()</code> methods.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a class="external" href="http://www.w3.org/TR/selectors-api/">Selectors API</a></li>
 <li>{{domxref("Element.querySelector()")}}</li>
 <li>{{domxref("Element.querySelectorAll()")}}</li>
 <li>{{domxref("Document.querySelector()")}}</li>
 <li>{{domxref("Document.querySelectorAll()")}}</li>
 <li><a href="/en-US/docs/Code_snippets/QuerySelector" title="en-US/docs/Code_snippets/QuerySelector">Code snippets for querySelector</a></li>
</ul>
